config/routes.rb
Tidbits::Engine.routes.draw do
  resources :tidbits, except: %(new create)
end

app/models/tidbits/application_record.rb
module Tidbits
  class ApplicationRecord < ActiveRecord::Base
    self.abstract_class = true
  end
end

app/models/tidbits/tidbit.rb
# frozen_string_literal: true

module Tidbits
  class Tidbit < ApplicationRecord
    def self.by_key(key)
      where(key: key.to_s.downcase).first_or_create
    end

    validates :key, presence: true, uniqueness: true
    has_rich_text :body

    def key
      self[:key].to_s.downcase
    end

    def key=(value)
      super(value.to_s.downcase)
    end
  end
end

app/controllers/tidbits/application_controller.rb
module Tidbits
  class ApplicationController < ActionController::Base
    protect_from_forgery with: :exception

    def configured_before_action
      action = ::Tidbits.config.before_action
      return true unless action

      if action.respond_to?(:call)
        action.call
      else
        public_send(action)
      end
    end
  end
end

app/controllers/tidbits/tidbits_controller.rb
require_dependency "tidbits/application_controller"

module Tidbits
  class TidbitsController < ApplicationController
    before_action :configured_before_action, except: :show
    before_action :find_tidbit, except: :index
    before_action :set_mode
    helper_method :previewing?

    def index
      @tidbits = Tidbit.all
    end

    def edit; end

    def update
      @tidbit.assign_attributes(tidbit_params)
      set_mode

      if previewing? || @tidbit.save
        render :show
      else
        @error = I18n.t(".error", default: "There was an error with your request. Please try again.")
        render :edit, status: :unprocessable_entity
      end
    rescue StandardError
      @error = I18n.t(".error", default: "There was an error with your request. Please try again.")
      render :edit, status: :internal_server_error
    end

    def show; end

    def previewing?
      params[:commit] == "Preview"
    end

    private

    def set_mode
      @plain = params[:plain] == "true"
    end

    def find_tidbit
      @tidbit = Tidbit.find(params[:id])
    end

    def tidbit_params
      params.require(:tidbit).permit(:body)
    end
  end
end

app/helpers/tidbits/application_helper.rb
module Tidbits
  module ApplicationHelper
  end
end

app/helpers/tidbits/tidbits_helper.rb
# frozen_string_literal: true

module Tidbits
  module TidbitsHelper
    def tidbit(key, editable: nil, plain: false, &block)
      editable = can_edit_tidbits? if editable.nil?

      tidbit = key.is_a?(Tidbit) ? key : Tidbit.by_key(key)
      render(tidbit, locals: { editable: editable, plain: plain }, &block)
    end

    def tidbits_form_container
      tag.turbo_frame "", id: "tidbit-form"
    end

    def can_edit_tidbits?
      action = ::Tidbits.config.can_edit
      return false unless action

      if action.respond_to?(:call)
        action.call
      else
        public_send(action)
      end
    end
  end
end

app/views/layouts/tidbits/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Tidbits</title>
  <%= csrf_meta_tags %>
  <%= csp_meta_tag %>

  <%= stylesheet_link_tag    "tidbits/application", media: "all" %>
</head>
<body>

<%= yield %>

</body>
</html>

app/views/tidbits/tidbits/_tidbit.html.erb
<%= tag.turbo_frame id: dom_id(tidbit), class: "relative block",
                    autoscroll: locals[:autoscroll], 
                    data: { autoscroll_block: "center", turbo: true } do %>
  
  <% if locals[:editable] %>
    <%= link_to "", tidbits.edit_tidbit_path(tidbit, ({ plain: true } if locals[:plain])), data: { turbo_frame: "tidbit-form" }, class: "block absolute left-0 bottom-0 right-0 top-0 border border-yellow-300 hover:border-yellow-500 transition" %> 
  <% end %>

  <%= tag.div class: "tidbit-body rounded-sm", data: { turbo_frame: "_top" } do %>
    <% if tidbit.body.present? %>
      <% if locals[:plain] %>
        <%= tidbit.body.to_plain_text %>
      <% else %>
        <%== tidbit.body %>
      <% end %>
    <% else %>
      <%= yield %>
    <% end %>
  <% end %>

  <%= tag.turbo_stream tag.template, action: :update, target: "tidbit-form" if locals[:clear_form] %>

<% end %>

app/views/tidbits/tidbits/edit.html.erb
<%= tag.turbo_frame id: "tidbit-form", autoscroll: true do %>
  <div class="fixed bottom-0 left-0 right-0 z-50 bg-white border-dotted border-t-4" role="dialog" aria-modal="true">
    <div class="mx-4 md:mx-12">
      <%= tag.h2 "Editing `#{@tidbit.key}`" %>
  
      <%= form_for @tidbit, data: { turbo_frame: dom_id(@tidbit) } do |f| %>
        <% if @plain %>
          <%= f.rich_text_area :body, data: { trix_config: "minimal" } %>
        <% else %>
          <%= f.rich_text_area :body, data: { trix_config: "full" } %>
        <% end %>

        <%= hidden_field_tag "plain", params[:plain] %>

        <div class="flex flex-wrap items-center align-middle mt-2 mb-6">
          <%= link_to 'Cancel', tidbit_path(@tidbit), class: "underline mr-2 text-sm text-red-500 hover:text-red-700 transition" %>
          <%= f.submit "Preview", class: "block md:inline-flex items-center justify-center px-4 py-2 mr-2 border border-gray-300 shadow-sm text-sm rounded-full text-link_primary hover:text-link_primary bg-white hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-link_primary transition" %>
          <%= f.submit "Save", class: "block md:inline-flex items-center justify-center px-4 py-2 mr-2 border border-gray-300 shadow-sm text-sm rounded-full text-white bg-link_primary hover:bg-link_hover focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-link_primary transition" %>
          <%= tag.span @error, class: "text-sm mr-2 text-red-500" %>
        </div>
      <% end %>
    </div>
  </div>
<% end %>

app/views/tidbits/tidbits/index.html.erb
<% @tidbits.each do |tidbit| %>
  <%= tag.h2 tidbit.key %>
  <%= tidbit(tidbit) %>
<% end %>

app/views/tidbits/tidbits/show.html.erb
<%= render @tidbit, locals: { plain: @plain, editable: can_edit_tidbits? && !previewing?, autoscroll: true, clear_form: !previewing? } %>